<?php

class VendorName_ModuleName_Model_Gdpr_Processor extends Plumrocket_GDPR_Model_AbstractProcessor implements
    Plumrocket_GDPR_Model_ProcessorInterface
{
    public function getKey()
    {
        return 'unique_key'; // unique key of your GDPR model
    }

    public function getModuleName()
    {
        return 'VendorName_ModuleName';
    }

    public function getPublicFilename()
    {
        return 'your_filename'; // your CSV file name
    }

    /**
     * @return array
     */
    public function getMapping()
    {
        return array(
            'db_field_name1' => array(
                // data anonymization options
                'anonymize' => 'bool',
                'default'   => 'string',
                // data export options
                'export'    => 'bool',
                'title'     => 'string',
                'decorator' => 'callable',
            ),
            'db_field_name2' => array(),
            'db_field_name3' => array(
                'export'    => 'bool',
                'title'     => 'string',
                'decorator' => 'callable',
            ),
        );
    }

    /**
     * @param Mage_Customer_Model_Customer $customer
     * @return bool
     */
    public function anonymize($customer)
    {
        $collection = $this->_getCollectionByCustomer($customer);

        return $this->_massAnonymize($collection);
    }

    /**
     * @param Mage_Customer_Model_Customer $customer
     * @return bool
     */
    public function erase($customer)
    {
        $collection = $this->_getCollectionByCustomer($customer);

        return $this->_massErase($collection);
    }

    /**
     * @param Mage_Customer_Model_Customer $customer
     * @return bool
     */
    public function export($customer)
    {
        $collection = $this->_getCollectionByCustomer($customer);

        return $this->_massExport($collection);
    }

    /**
     * @param Mage_Customer_Model_Customer $customer
     * @return Mage_Core_Model_Abstract[]
     */
    protected function _getCollectionByCustomer($customer)
    {
        /** @var Mage_Core_Model_Resource_Db_Collection_Abstract $collection */
        $collection = Mage::getModel('groupedClassName/entity_name')->getCollection();
        $collection->addFieldToFilter('customer_id', $customer->getId());

        return $collection->getItems();
    }
}
